/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-sr-robot-msgs-1.3.5-2quantal-20150328-0700/msg/Biotac.msg
 *
 */


#ifndef SR_ROBOT_MSGS_MESSAGE_BIOTAC_H
#define SR_ROBOT_MSGS_MESSAGE_BIOTAC_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace sr_robot_msgs
{
template <class ContainerAllocator>
struct Biotac_
{
  typedef Biotac_<ContainerAllocator> Type;

  Biotac_()
    : pac0(0)
    , pac1(0)
    , pdc(0)
    , tac(0)
    , tdc(0)
    , electrodes()  {
      electrodes.assign(0);
  }
  Biotac_(const ContainerAllocator& _alloc)
    : pac0(0)
    , pac1(0)
    , pdc(0)
    , tac(0)
    , tdc(0)
    , electrodes()  {
      electrodes.assign(0);
  }



   typedef int16_t _pac0_type;
  _pac0_type pac0;

   typedef int16_t _pac1_type;
  _pac1_type pac1;

   typedef int16_t _pdc_type;
  _pdc_type pdc;

   typedef int16_t _tac_type;
  _tac_type tac;

   typedef int16_t _tdc_type;
  _tdc_type tdc;

   typedef boost::array<int16_t, 19>  _electrodes_type;
  _electrodes_type electrodes;




  typedef boost::shared_ptr< ::sr_robot_msgs::Biotac_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::sr_robot_msgs::Biotac_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Biotac_

typedef ::sr_robot_msgs::Biotac_<std::allocator<void> > Biotac;

typedef boost::shared_ptr< ::sr_robot_msgs::Biotac > BiotacPtr;
typedef boost::shared_ptr< ::sr_robot_msgs::Biotac const> BiotacConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::sr_robot_msgs::Biotac_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::sr_robot_msgs::Biotac_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace sr_robot_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'sr_robot_msgs': ['/tmp/buildd/ros-hydro-sr-robot-msgs-1.3.5-2quantal-20150328-0700/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::sr_robot_msgs::Biotac_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::sr_robot_msgs::Biotac_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sr_robot_msgs::Biotac_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sr_robot_msgs::Biotac_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sr_robot_msgs::Biotac_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sr_robot_msgs::Biotac_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::sr_robot_msgs::Biotac_<ContainerAllocator> >
{
  static const char* value()
  {
    return "45887a982dc5cee83be90c94c9db9f12";
  }

  static const char* value(const ::sr_robot_msgs::Biotac_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x45887a982dc5cee8ULL;
  static const uint64_t static_value2 = 0x3be90c94c9db9f12ULL;
};

template<class ContainerAllocator>
struct DataType< ::sr_robot_msgs::Biotac_<ContainerAllocator> >
{
  static const char* value()
  {
    return "sr_robot_msgs/Biotac";
  }

  static const char* value(const ::sr_robot_msgs::Biotac_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::sr_robot_msgs::Biotac_<ContainerAllocator> >
{
  static const char* value()
  {
    return "int16 pac0\n\
int16 pac1\n\
int16 pdc\n\
\n\
int16 tac\n\
int16 tdc\n\
\n\
int16[19] electrodes\n\
";
  }

  static const char* value(const ::sr_robot_msgs::Biotac_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::sr_robot_msgs::Biotac_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.pac0);
      stream.next(m.pac1);
      stream.next(m.pdc);
      stream.next(m.tac);
      stream.next(m.tdc);
      stream.next(m.electrodes);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Biotac_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::sr_robot_msgs::Biotac_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::sr_robot_msgs::Biotac_<ContainerAllocator>& v)
  {
    s << indent << "pac0: ";
    Printer<int16_t>::stream(s, indent + "  ", v.pac0);
    s << indent << "pac1: ";
    Printer<int16_t>::stream(s, indent + "  ", v.pac1);
    s << indent << "pdc: ";
    Printer<int16_t>::stream(s, indent + "  ", v.pdc);
    s << indent << "tac: ";
    Printer<int16_t>::stream(s, indent + "  ", v.tac);
    s << indent << "tdc: ";
    Printer<int16_t>::stream(s, indent + "  ", v.tdc);
    s << indent << "electrodes[]" << std::endl;
    for (size_t i = 0; i < v.electrodes.size(); ++i)
    {
      s << indent << "  electrodes[" << i << "]: ";
      Printer<int16_t>::stream(s, indent + "  ", v.electrodes[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // SR_ROBOT_MSGS_MESSAGE_BIOTAC_H
