/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-sr-robot-msgs-1.3.5-2quantal-20150328-0700/srv/ChangeMotorSystemControls.srv
 *
 */


#ifndef SR_ROBOT_MSGS_MESSAGE_CHANGEMOTORSYSTEMCONTROLSREQUEST_H
#define SR_ROBOT_MSGS_MESSAGE_CHANGEMOTORSYSTEMCONTROLSREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <sr_robot_msgs/MotorSystemControls.h>

namespace sr_robot_msgs
{
template <class ContainerAllocator>
struct ChangeMotorSystemControlsRequest_
{
  typedef ChangeMotorSystemControlsRequest_<ContainerAllocator> Type;

  ChangeMotorSystemControlsRequest_()
    : motor_system_controls()  {
    }
  ChangeMotorSystemControlsRequest_(const ContainerAllocator& _alloc)
    : motor_system_controls(_alloc)  {
    }



   typedef std::vector< ::sr_robot_msgs::MotorSystemControls_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::sr_robot_msgs::MotorSystemControls_<ContainerAllocator> >::other >  _motor_system_controls_type;
  _motor_system_controls_type motor_system_controls;




  typedef boost::shared_ptr< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ChangeMotorSystemControlsRequest_

typedef ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<std::allocator<void> > ChangeMotorSystemControlsRequest;

typedef boost::shared_ptr< ::sr_robot_msgs::ChangeMotorSystemControlsRequest > ChangeMotorSystemControlsRequestPtr;
typedef boost::shared_ptr< ::sr_robot_msgs::ChangeMotorSystemControlsRequest const> ChangeMotorSystemControlsRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace sr_robot_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'sr_robot_msgs': ['/tmp/buildd/ros-hydro-sr-robot-msgs-1.3.5-2quantal-20150328-0700/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "6458c2239125c960f4d1ef4d23696a1e";
  }

  static const char* value(const ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x6458c2239125c960ULL;
  static const uint64_t static_value2 = 0xf4d1ef4d23696a1eULL;
};

template<class ContainerAllocator>
struct DataType< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "sr_robot_msgs/ChangeMotorSystemControlsRequest";
  }

  static const char* value(const ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "MotorSystemControls[] motor_system_controls\n\
\n\
================================================================================\n\
MSG: sr_robot_msgs/MotorSystemControls\n\
int8 motor_id                     # the id of the motor you want to control\n\
\n\
bool enable_backlash_compensation # switch on/off backlash compensation at the motor level\n\
bool increase_sgl_tracking        # increment the tracking value for the left gauge\n\
bool decrease_sgl_tracking        # decrement the tracking value for the left gauge\n\
bool increase_sgr_tracking        # increment the tracking value for the right gauge\n\
bool decrease_sgr_tracking        # decrement the tracking value for the right gauge\n\
bool initiate_jiggling            # starts jiggling the given motor\n\
bool write_config_to_eeprom       # write the current configuration to the eeprom\n\
";
  }

  static const char* value(const ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.motor_system_controls);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ChangeMotorSystemControlsRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::sr_robot_msgs::ChangeMotorSystemControlsRequest_<ContainerAllocator>& v)
  {
    s << indent << "motor_system_controls[]" << std::endl;
    for (size_t i = 0; i < v.motor_system_controls.size(); ++i)
    {
      s << indent << "  motor_system_controls[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::sr_robot_msgs::MotorSystemControls_<ContainerAllocator> >::stream(s, indent + "    ", v.motor_system_controls[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // SR_ROBOT_MSGS_MESSAGE_CHANGEMOTORSYSTEMCONTROLSREQUEST_H
