/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-sr-robot-msgs-1.3.5-2quantal-20150328-0700/msg/EthercatDebug.msg
 *
 */


#ifndef SR_ROBOT_MSGS_MESSAGE_ETHERCATDEBUG_H
#define SR_ROBOT_MSGS_MESSAGE_ETHERCATDEBUG_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <sr_robot_msgs/FromMotorDataType.h>

namespace sr_robot_msgs
{
template <class ContainerAllocator>
struct EthercatDebug_
{
  typedef EthercatDebug_<ContainerAllocator> Type;

  EthercatDebug_()
    : header()
    , sensors()
    , motor_data_type()
    , which_motors(0)
    , which_motor_data_arrived(0)
    , which_motor_data_had_errors(0)
    , motor_data_packet_torque()
    , motor_data_packet_misc()
    , tactile_data_type(0)
    , tactile_data_valid(0)
    , tactile()
    , idle_time_us(0)  {
    }
  EthercatDebug_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , sensors(_alloc)
    , motor_data_type(_alloc)
    , which_motors(0)
    , which_motor_data_arrived(0)
    , which_motor_data_had_errors(0)
    , motor_data_packet_torque(_alloc)
    , motor_data_packet_misc(_alloc)
    , tactile_data_type(0)
    , tactile_data_valid(0)
    , tactile(_alloc)
    , idle_time_us(0)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::vector<int16_t, typename ContainerAllocator::template rebind<int16_t>::other >  _sensors_type;
  _sensors_type sensors;

   typedef  ::sr_robot_msgs::FromMotorDataType_<ContainerAllocator>  _motor_data_type_type;
  _motor_data_type_type motor_data_type;

   typedef int16_t _which_motors_type;
  _which_motors_type which_motors;

   typedef int32_t _which_motor_data_arrived_type;
  _which_motor_data_arrived_type which_motor_data_arrived;

   typedef int32_t _which_motor_data_had_errors_type;
  _which_motor_data_had_errors_type which_motor_data_had_errors;

   typedef std::vector<int16_t, typename ContainerAllocator::template rebind<int16_t>::other >  _motor_data_packet_torque_type;
  _motor_data_packet_torque_type motor_data_packet_torque;

   typedef std::vector<int16_t, typename ContainerAllocator::template rebind<int16_t>::other >  _motor_data_packet_misc_type;
  _motor_data_packet_misc_type motor_data_packet_misc;

   typedef int32_t _tactile_data_type_type;
  _tactile_data_type_type tactile_data_type;

   typedef int16_t _tactile_data_valid_type;
  _tactile_data_valid_type tactile_data_valid;

   typedef std::vector<int16_t, typename ContainerAllocator::template rebind<int16_t>::other >  _tactile_type;
  _tactile_type tactile;

   typedef int16_t _idle_time_us_type;
  _idle_time_us_type idle_time_us;




  typedef boost::shared_ptr< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct EthercatDebug_

typedef ::sr_robot_msgs::EthercatDebug_<std::allocator<void> > EthercatDebug;

typedef boost::shared_ptr< ::sr_robot_msgs::EthercatDebug > EthercatDebugPtr;
typedef boost::shared_ptr< ::sr_robot_msgs::EthercatDebug const> EthercatDebugConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace sr_robot_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'sr_robot_msgs': ['/tmp/buildd/ros-hydro-sr-robot-msgs-1.3.5-2quantal-20150328-0700/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ed9e30784a7d4571ecf4d526e7ff529f";
  }

  static const char* value(const ::sr_robot_msgs::EthercatDebug_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xed9e30784a7d4571ULL;
  static const uint64_t static_value2 = 0xecf4d526e7ff529fULL;
};

template<class ContainerAllocator>
struct DataType< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> >
{
  static const char* value()
  {
    return "sr_robot_msgs/EthercatDebug";
  }

  static const char* value(const ::sr_robot_msgs::EthercatDebug_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header               header\n\
\n\
int16[]              sensors\n\
FromMotorDataType    motor_data_type\n\
int16                which_motors\n\
int32                which_motor_data_arrived\n\
int32                which_motor_data_had_errors\n\
int16[]              motor_data_packet_torque\n\
int16[]              motor_data_packet_misc\n\
int32                tactile_data_type\n\
int16                tactile_data_valid\n\
int16[]              tactile\n\
int16                idle_time_us\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: sr_robot_msgs/FromMotorDataType\n\
int16 data\n\
";
  }

  static const char* value(const ::sr_robot_msgs::EthercatDebug_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.sensors);
      stream.next(m.motor_data_type);
      stream.next(m.which_motors);
      stream.next(m.which_motor_data_arrived);
      stream.next(m.which_motor_data_had_errors);
      stream.next(m.motor_data_packet_torque);
      stream.next(m.motor_data_packet_misc);
      stream.next(m.tactile_data_type);
      stream.next(m.tactile_data_valid);
      stream.next(m.tactile);
      stream.next(m.idle_time_us);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct EthercatDebug_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::sr_robot_msgs::EthercatDebug_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::sr_robot_msgs::EthercatDebug_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "sensors[]" << std::endl;
    for (size_t i = 0; i < v.sensors.size(); ++i)
    {
      s << indent << "  sensors[" << i << "]: ";
      Printer<int16_t>::stream(s, indent + "  ", v.sensors[i]);
    }
    s << indent << "motor_data_type: ";
    s << std::endl;
    Printer< ::sr_robot_msgs::FromMotorDataType_<ContainerAllocator> >::stream(s, indent + "  ", v.motor_data_type);
    s << indent << "which_motors: ";
    Printer<int16_t>::stream(s, indent + "  ", v.which_motors);
    s << indent << "which_motor_data_arrived: ";
    Printer<int32_t>::stream(s, indent + "  ", v.which_motor_data_arrived);
    s << indent << "which_motor_data_had_errors: ";
    Printer<int32_t>::stream(s, indent + "  ", v.which_motor_data_had_errors);
    s << indent << "motor_data_packet_torque[]" << std::endl;
    for (size_t i = 0; i < v.motor_data_packet_torque.size(); ++i)
    {
      s << indent << "  motor_data_packet_torque[" << i << "]: ";
      Printer<int16_t>::stream(s, indent + "  ", v.motor_data_packet_torque[i]);
    }
    s << indent << "motor_data_packet_misc[]" << std::endl;
    for (size_t i = 0; i < v.motor_data_packet_misc.size(); ++i)
    {
      s << indent << "  motor_data_packet_misc[" << i << "]: ";
      Printer<int16_t>::stream(s, indent + "  ", v.motor_data_packet_misc[i]);
    }
    s << indent << "tactile_data_type: ";
    Printer<int32_t>::stream(s, indent + "  ", v.tactile_data_type);
    s << indent << "tactile_data_valid: ";
    Printer<int16_t>::stream(s, indent + "  ", v.tactile_data_valid);
    s << indent << "tactile[]" << std::endl;
    for (size_t i = 0; i < v.tactile.size(); ++i)
    {
      s << indent << "  tactile[" << i << "]: ";
      Printer<int16_t>::stream(s, indent + "  ", v.tactile[i]);
    }
    s << indent << "idle_time_us: ";
    Printer<int16_t>::stream(s, indent + "  ", v.idle_time_us);
  }
};

} // namespace message_operations
} // namespace ros

#endif // SR_ROBOT_MSGS_MESSAGE_ETHERCATDEBUG_H
