/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-sr-robot-msgs-1.3.5-2quantal-20150328-0700/srv/SetDebugData.srv
 *
 */


#ifndef SR_ROBOT_MSGS_MESSAGE_SETDEBUGDATAREQUEST_H
#define SR_ROBOT_MSGS_MESSAGE_SETDEBUGDATAREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace sr_robot_msgs
{
template <class ContainerAllocator>
struct SetDebugDataRequest_
{
  typedef SetDebugDataRequest_<ContainerAllocator> Type;

  SetDebugDataRequest_()
    : motor_index(0)
    , motor_data_type(0)
    , publisher_index(0)  {
    }
  SetDebugDataRequest_(const ContainerAllocator& _alloc)
    : motor_index(0)
    , motor_data_type(0)
    , publisher_index(0)  {
    }



   typedef int16_t _motor_index_type;
  _motor_index_type motor_index;

   typedef int16_t _motor_data_type_type;
  _motor_data_type_type motor_data_type;

   typedef int16_t _publisher_index_type;
  _publisher_index_type publisher_index;




  typedef boost::shared_ptr< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SetDebugDataRequest_

typedef ::sr_robot_msgs::SetDebugDataRequest_<std::allocator<void> > SetDebugDataRequest;

typedef boost::shared_ptr< ::sr_robot_msgs::SetDebugDataRequest > SetDebugDataRequestPtr;
typedef boost::shared_ptr< ::sr_robot_msgs::SetDebugDataRequest const> SetDebugDataRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace sr_robot_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'sr_robot_msgs': ['/tmp/buildd/ros-hydro-sr-robot-msgs-1.3.5-2quantal-20150328-0700/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "9f31db3c8e178b58a93d06e8bde6a17a";
  }

  static const char* value(const ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x9f31db3c8e178b58ULL;
  static const uint64_t static_value2 = 0xa93d06e8bde6a17aULL;
};

template<class ContainerAllocator>
struct DataType< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "sr_robot_msgs/SetDebugDataRequest";
  }

  static const char* value(const ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
\n\
\n\
\n\
int16 motor_index\n\
int16 motor_data_type\n\
int16 publisher_index\n\
";
  }

  static const char* value(const ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.motor_index);
      stream.next(m.motor_data_type);
      stream.next(m.publisher_index);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SetDebugDataRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::sr_robot_msgs::SetDebugDataRequest_<ContainerAllocator>& v)
  {
    s << indent << "motor_index: ";
    Printer<int16_t>::stream(s, indent + "  ", v.motor_index);
    s << indent << "motor_data_type: ";
    Printer<int16_t>::stream(s, indent + "  ", v.motor_data_type);
    s << indent << "publisher_index: ";
    Printer<int16_t>::stream(s, indent + "  ", v.publisher_index);
  }
};

} // namespace message_operations
} // namespace ros

#endif // SR_ROBOT_MSGS_MESSAGE_SETDEBUGDATAREQUEST_H
