/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-sr-robot-msgs-1.3.5-2quantal-20150328-0700/srv/SetMixedPositionVelocityPidGains.srv
 *
 */


#ifndef SR_ROBOT_MSGS_MESSAGE_SETMIXEDPOSITIONVELOCITYPIDGAINSREQUEST_H
#define SR_ROBOT_MSGS_MESSAGE_SETMIXEDPOSITIONVELOCITYPIDGAINSREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace sr_robot_msgs
{
template <class ContainerAllocator>
struct SetMixedPositionVelocityPidGainsRequest_
{
  typedef SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> Type;

  SetMixedPositionVelocityPidGainsRequest_()
    : position_p(0.0)
    , position_i(0.0)
    , position_d(0.0)
    , position_i_clamp(0.0)
    , min_velocity(0.0)
    , max_velocity(0.0)
    , position_deadband(0.0)
    , velocity_p(0.0)
    , velocity_i(0.0)
    , velocity_d(0.0)
    , velocity_i_clamp(0.0)
    , max_force(0.0)
    , friction_deadband(0)  {
    }
  SetMixedPositionVelocityPidGainsRequest_(const ContainerAllocator& _alloc)
    : position_p(0.0)
    , position_i(0.0)
    , position_d(0.0)
    , position_i_clamp(0.0)
    , min_velocity(0.0)
    , max_velocity(0.0)
    , position_deadband(0.0)
    , velocity_p(0.0)
    , velocity_i(0.0)
    , velocity_d(0.0)
    , velocity_i_clamp(0.0)
    , max_force(0.0)
    , friction_deadband(0)  {
    }



   typedef double _position_p_type;
  _position_p_type position_p;

   typedef double _position_i_type;
  _position_i_type position_i;

   typedef double _position_d_type;
  _position_d_type position_d;

   typedef double _position_i_clamp_type;
  _position_i_clamp_type position_i_clamp;

   typedef double _min_velocity_type;
  _min_velocity_type min_velocity;

   typedef double _max_velocity_type;
  _max_velocity_type max_velocity;

   typedef double _position_deadband_type;
  _position_deadband_type position_deadband;

   typedef double _velocity_p_type;
  _velocity_p_type velocity_p;

   typedef double _velocity_i_type;
  _velocity_i_type velocity_i;

   typedef double _velocity_d_type;
  _velocity_d_type velocity_d;

   typedef double _velocity_i_clamp_type;
  _velocity_i_clamp_type velocity_i_clamp;

   typedef double _max_force_type;
  _max_force_type max_force;

   typedef int32_t _friction_deadband_type;
  _friction_deadband_type friction_deadband;




  typedef boost::shared_ptr< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SetMixedPositionVelocityPidGainsRequest_

typedef ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<std::allocator<void> > SetMixedPositionVelocityPidGainsRequest;

typedef boost::shared_ptr< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest > SetMixedPositionVelocityPidGainsRequestPtr;
typedef boost::shared_ptr< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest const> SetMixedPositionVelocityPidGainsRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace sr_robot_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'sr_robot_msgs': ['/tmp/buildd/ros-hydro-sr-robot-msgs-1.3.5-2quantal-20150328-0700/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ff95ce4d442c9454d3d943f0c999da89";
  }

  static const char* value(const ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xff95ce4d442c9454ULL;
  static const uint64_t static_value2 = 0xd3d943f0c999da89ULL;
};

template<class ContainerAllocator>
struct DataType< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "sr_robot_msgs/SetMixedPositionVelocityPidGainsRequest";
  }

  static const char* value(const ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64 position_p\n\
float64 position_i\n\
float64 position_d\n\
float64 position_i_clamp\n\
float64 min_velocity\n\
float64 max_velocity\n\
float64 position_deadband\n\
\n\
float64 velocity_p\n\
float64 velocity_i\n\
float64 velocity_d\n\
float64 velocity_i_clamp\n\
float64 max_force\n\
\n\
int32 friction_deadband\n\
";
  }

  static const char* value(const ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.position_p);
      stream.next(m.position_i);
      stream.next(m.position_d);
      stream.next(m.position_i_clamp);
      stream.next(m.min_velocity);
      stream.next(m.max_velocity);
      stream.next(m.position_deadband);
      stream.next(m.velocity_p);
      stream.next(m.velocity_i);
      stream.next(m.velocity_d);
      stream.next(m.velocity_i_clamp);
      stream.next(m.max_force);
      stream.next(m.friction_deadband);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SetMixedPositionVelocityPidGainsRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::sr_robot_msgs::SetMixedPositionVelocityPidGainsRequest_<ContainerAllocator>& v)
  {
    s << indent << "position_p: ";
    Printer<double>::stream(s, indent + "  ", v.position_p);
    s << indent << "position_i: ";
    Printer<double>::stream(s, indent + "  ", v.position_i);
    s << indent << "position_d: ";
    Printer<double>::stream(s, indent + "  ", v.position_d);
    s << indent << "position_i_clamp: ";
    Printer<double>::stream(s, indent + "  ", v.position_i_clamp);
    s << indent << "min_velocity: ";
    Printer<double>::stream(s, indent + "  ", v.min_velocity);
    s << indent << "max_velocity: ";
    Printer<double>::stream(s, indent + "  ", v.max_velocity);
    s << indent << "position_deadband: ";
    Printer<double>::stream(s, indent + "  ", v.position_deadband);
    s << indent << "velocity_p: ";
    Printer<double>::stream(s, indent + "  ", v.velocity_p);
    s << indent << "velocity_i: ";
    Printer<double>::stream(s, indent + "  ", v.velocity_i);
    s << indent << "velocity_d: ";
    Printer<double>::stream(s, indent + "  ", v.velocity_d);
    s << indent << "velocity_i_clamp: ";
    Printer<double>::stream(s, indent + "  ", v.velocity_i_clamp);
    s << indent << "max_force: ";
    Printer<double>::stream(s, indent + "  ", v.max_force);
    s << indent << "friction_deadband: ";
    Printer<int32_t>::stream(s, indent + "  ", v.friction_deadband);
  }
};

} // namespace message_operations
} // namespace ros

#endif // SR_ROBOT_MSGS_MESSAGE_SETMIXEDPOSITIONVELOCITYPIDGAINSREQUEST_H
